/*
	IntelHEX`(hex.c)
*/

#include <stdio.h>
#include <string.h>
#include "hex.h"

#define FALSE	0
#define TRUE	1

/*
	𐔒l(1byte)ɕϊ ()
*/
static int h2i(char c)
{
	switch(c) {
	case '0':
		return 0;
	case '1':
		return 1;
	case '2':
		return 2;
	case '3':
		return 3;
	case '4':
		return 4;
	case '5':
		return 5;
	case '6':
		return 6;
	case '7':
		return 7;
	case '8':
		return 8;
	case '9':
		return 9;
	case 'A':
	case 'a':
		return 0xa;
	case 'B':
	case 'b':
		return 0xb;
	case 'C':
	case 'c':
		return 0xc;
	case 'D':
	case 'd':
		return 0xd;
	case 'E':
	case 'e':
		return 0xe;
	case 'F':
	case 'f':
		return 0xf;
	default:
		return -16;
	}
}
static int hex2i(const char *hex)
{
	int val;

	if((val = (h2i(*hex) << 4) | h2i(*(hex + 1))) < 0)
		return -1;
	return val;
}

/*
	IntelHEX`̃eLXgoCiɕϊ ()
*/
static off_t hex2bin(unsigned char *mem, off_t *off, const char *txt, size_t mem_size, int check)
{
	int i, len, val, sum = 0;
	const char *r = txt;
	unsigned char *w;

	/* R[h擪L */
	if(*r++ != ':')
		return -1;
	
	/* f[^ */
	len = hex2i(r);
	if(len < 0)
		return -1;
	if(len == 0)
		return 0;
	r += 2;
	sum += (len & 0xff);

	/* ItZbgAhX */
	*off = (hex2i(r + 0) << 8) | hex2i(r + 2);
	if(*off < 0)
		return -1;
	r += 4;
	sum += ((*off & 0xff00) >> 8) + (*off & 0x00ff);

	/* R[h^Cv */
	switch(hex2i(r)) {
	case 0x00:	/* f[^R[h */
		break;
	case 0x01:	/* GhR[h */
		return 0;
	default:	/* ̑̃R[h(Ή) */
		return -1;
	}
	r += 2;
	sum += 0;

	/* f[^ */
	for(
	i = 0, w = mem + *off;
	i < len && w < mem + mem_size;
	i++, w++, r += 2
	) {
		if((val = hex2i(r)) < 0)
			return -1;
		if(mem != NULL)
			*w = val;
		sum += val;
	}
	sum = (~sum + 1) & 0xff;

	/* `FbNT */
	if(check && hex2i(r) != sum)
		return -1;

	return (mem != NULL ? (int )(w - mem - *off): len);
}

/*
	l(1byte)𕶎ɕϊ ()
*/
static char *int2c(char *hex, int i)
{
	const static char int_to_ascii[] = {
		'0', '1', '2', '3', '4', '5', '6', '7',
		'8', '9', 'A', 'B', 'C', 'D', 'E', 'F'
	};

	hex[0] = int_to_ascii[i >> 4];
	hex[1] = int_to_ascii[i & 0xf];
	return hex;
}

/*
	oCiIntelHEX`̃eLXgɕϊ ()
*/
static char *bin2hex(char *txt, const unsigned char *mem, off_t off, off_t len)
{
	int sum;
	const unsigned char *r = mem;
	char *w = txt;

	if(len <= 0) {
		/* GhR[h */
		strcpy(txt, ":00000001FF\n");
		return txt;
	}

	/* R[hJnL */
	*w++ = ':';

	/* f[^ */
	int2c(w, len);
	w += 2;
	sum = (len & 0xff);
	
	/* ItZbgAhX */
	int2c(w, (off & 0xff00) >> 8);
	w += 2;
	int2c(w, off & 0x00ff);
	w += 2;
	sum += ((off & 0xff00) >> 8) + (off & 0x00ff);
	
	/* R[h^Cv */
	memcpy(w, "00", 2);
	w += 2;
	sum += 0;
	
	/* f[^ */
	for(r = mem + off; r != mem + off + len; r++, w += 2) {
		int2c(w, *r);
		sum += *r;
	}

	/* `FbNT */
	int2c(w, (~sum + 1) & 0xff);
	w += 2;

	/* s */
	*w++ = '\n';
	*w = 0;

	return txt;
}

/*
	IntelHEX`t@Cǂݍ
*/
size_t readHex(const char *path, void *mem, off_t *ret_begin, size_t mem_size, int check)
{
	FILE *fp;
	off_t offset, begin = 0xffff, last = 0, len;
	char buf[256];

	if(path == NULL || (fp = fopen(path, "r")) == NULL)
		return 0;
	while(!feof(fp)) {
		fgets(buf, sizeof(buf), fp);
		len = hex2bin(mem, &offset, buf, mem_size, check);
		if(len < 0 || len == sizeof(buf)) {
			/* sȃR[h */
			fclose(fp);
			return 0;
		} else if (len == 0) {
			/* GhR[h */
			break;
		} else {
			/* f[^R[h */
			begin = (begin < offset ? begin: offset);
			last = (last > offset + len ? last: offset + len);
		}
	}
	fclose(fp);

	if(ret_begin != NULL)
		*ret_begin = begin;
	return (begin > last ? 0: last - begin);
}

/*
	IntelHEX`t@Cǂݍ(t@C̃AhX𖳎)
*/
size_t readHexAbs(const char *path, void *mem, off_t *ret_begin, size_t mem_size, int check)
{
	size_t size;
	off_t begin;

	if((size = readHex(path, NULL, &begin, 0xffff, check)) == 0)
		return 0;
	if(ret_begin != NULL)
		*ret_begin = begin;
	return readHex(path, (mem != NULL ? (unsigned char *)mem - begin: NULL), NULL, mem_size + begin, check);
}

/*
	IntelHEX`t@C
*/
size_t writeHex(const char *path, const void *mem, off_t begin, size_t size)
{
	FILE *fp;
	off_t offset, len;
	char buf[256];
	
	if(path == NULL || (fp = fopen(path, "w")) == NULL)
		return 0;
	for(offset = begin; offset < begin + size; offset += 16) {
		if((len = begin + size - offset) > 16)
			len = 16;
		bin2hex(buf, mem, offset, len);
		fputs(buf, fp);
	}
	bin2hex(buf, NULL, 0, 0);
	fputs(buf, fp);
	fclose(fp);

	return size;
}

/*
	IntelHEX`t@C(̐擪珑)
*/
size_t writeHexAbs(const char *path, const void *mem, off_t begin, size_t size)
{
	return writeHex(path, (unsigned char *)mem - begin, begin, size);
}

/*
	Copyright 2005 ~ 2008 maruhiro
	All rights reserved. 

	Redistribution and use in source and binary forms, 
	with or without modification, are permitted provided that 
	the following conditions are met: 

	 1. Redistributions of source code must retain the above copyright notice, 
	    this list of conditions and the following disclaimer. 

	 2. Redistributions in binary form must reproduce the above copyright notice, 
	    this list of conditions and the following disclaimer in the documentation 
	    and/or other materials provided with the distribution. 

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
	FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
	THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* eof */
