/*
	SHARP PC-G800 series emulator
	̑̋@\
*/

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "g800.h"

#if !defined(O_BINARY)
#	define O_BINARY	0
#endif

/*
	g[Xo͂
*/
void z80log(const Z80stat *z)
{
	char buf[256];
	int states = Z80_STATES(z);

	printf("%s%dclocks (%dmsec)\n\n", z80regs(buf, z), states, states / (freqCPU / 1000));
}

/*
	oCit@Cǂݍ
*/
size_t readBin(const char *path, void *mem, size_t mem_size)
{
	size_t size;
	int fd;

	if(path == NULL || (fd = open(path, O_RDONLY | O_BINARY)) < 0)
		return 0;
	if(mem != NULL)
		size = read(fd, mem, mem_size);
	else {
		size = lseek(fd, 0, SEEK_END);
		size = (size < mem_size ? size: mem_size);
	}
	close(fd);

	return size;
}

/*
	oCit@C
*/
size_t writeBin(const char *path, const void *mem, size_t size)
{
	size_t written_size;
	int fd;

	if(path == NULL || (fd = open(path, O_CREAT | O_TRUNC | O_WRONLY | O_BINARY, 0664)) < 0)
		return 0;
	written_size = write(fd, mem, size);
	close(fd);

	return written_size;
}

/*
	Copyright 2005 ~ 2008 maruhiro
	All rights reserved. 

	Redistribution and use in source and binary forms, 
	with or without modification, are permitted provided that 
	the following conditions are met: 

	 1. Redistributions of source code must retain the above copyright notice, 
	    this list of conditions and the following disclaimer. 

	 2. Redistributions in binary form must reproduce the above copyright notice, 
	    this list of conditions and the following disclaimer in the documentation 
	    and/or other materials provided with the distribution. 

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
	FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
	THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* eof */
